version: "3.4"

services:
  php:
    build:
      context: .
      target: php_les_bases
    restart: unless-stopped
    healthcheck:
      interval: 10s
      timeout: 3s
      retries: 3
      start_period: 30s
    volumes:
      - ./:/srv/:rw,cached
      - php_socket:/var/run/php
    environment:
      APP_ENV: dev
      XDEBUG_MODE: debug
      PHP_IDE_CONFIG: serverName=php-les-bases
      XDEBUG_CONFIG: >-
        idekey=VSCODE
        client_host=docker.for.mac.localhost

  caddy:
    build:
      context: .
      target: php_les_bases_caddy
    depends_on:
      - php
    environment:
      SERVER_NAME: ${SERVER_NAME:-localhost, caddy:80}
    restart: unless-stopped
    volumes:
      - php_socket:/var/run/php
      - caddy_data:/data
      - caddy_config:/config
    ports:
      # HTTP
      - target: 80
        published: ${HTTP_PORT:-80}
        protocol: tcp
      # HTTPS
      - target: 443
        published: ${HTTPS_PORT:-443}
        protocol: tcp
      # HTTP/3
      - target: 443
        published: ${HTTP3_PORT:-443}
        protocol: udp

volumes:
  php_socket:
  caddy_data:
  caddy_config:
